//Here are some useful articles when creating new PC applications for COM ports:
//(links valid as of June 3, 2008)
//
//"SerialPort Class"
//http://msdn.microsoft.com/en-us/library/system.io.ports.serialport.aspx
//
//"SerialPort Members"
//http://msdn.microsoft.com/en-us/library/system.io.ports.serialport_members.aspx
//
//"SerialPort.DataReceived Event"
//http://msdn.microsoft.com/en-us/library/system.io.ports.serialport.datareceived.aspx
//
//"How to: Make Thread-Safe Calls to Windows Forms Controls"
//http://msdn.microsoft.com/en-us/library/ms171728(VS.80).aspx
//
//"The C# Language"
//http://msdn.microsoft.com/en-us/vcsharp/aa336809.aspx
//
//"C# Tutorials"
//http://msdn.microsoft.com/en-us/library/aa288436.aspxusing System;

using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace Csharp_Simple_CDC_Demo
{
    public partial class Form1 : Form
    {
        long gTime = 0;
        //txtDataReceivedeLXg{bNXɕރXbĥ߂̃fQ[g֐쐬܂
        delegate void SetTextCallback(string text);

        //Form1NX̃RXgN^B̊֐쐬tH[IuWFNĝׂĂ܂B
        public Form1()
        {
            InitializeComponent();
            //Initialize the COM ports list
            UpdateCOMPortList();
        }

        //IɋNACOM|[g̃Xg{bNXXV܂B
        private void UpdateCOMPortList()
        {
            int i;
            bool foundDifference;

            i = 0;
            foundDifference = false;

            //If the number of COM ports is different than the last time we
            //  checked, then we know that the COM ports have changed and we
            //  don't need to verify each entry.
            if (lstCOMPorts.Items.Count == SerialPort.GetPortNames().Length)
            {
                //Search the entire SerialPort object.  Look at COM port name
                //  returned and see if it already exists in the list.
                foreach (string s in SerialPort.GetPortNames())
                {
                    //If any of the names have changed then we need to update 
                    //  the list
                    if (lstCOMPorts.Items[i++].Equals(s) == false)
                    {
                        foundDifference = true;
                    }
                }
            }
            else
            {
                foundDifference = true;
            }

            //If nothing has changed, exit the function.
            if (foundDifference == false)
            {
                return;
            }

            //If something has changed, then clear the list
            lstCOMPorts.Items.Clear();

            //Add all of the current COM ports to the list
            foreach (string s in SerialPort.GetPortNames())
            {
                lstCOMPorts.Items.Add(s);
            }
            //Set the listbox to point to the first entry in the list
            lstCOMPorts.SelectedIndex = 0;
        }

        //Timer1Intervalɐݒ肵lmsɎs܂B
        private void timer1_Tick(object sender, System.EventArgs e)
        {
            //Update the COM ports list so that we can detect
            //  new COM ports that have been added.
            UpdateCOMPortList();
            gTime++;
        }


        //Connect{^Ǝs܂B
        private void btnConnect_Click(object sender, System.EventArgs e)
        {
            try
            {
                //Get the port name from the application list box.
                //  the PortName attribute is a string name of the COM port (e.g. - "COM1").
                serialPort1.PortName = lstCOMPorts.Items[lstCOMPorts.SelectedIndex].ToString();

                //Open the COM port.
                serialPort1.Open();

                //Change the state of the application objects
                btnConnect.Enabled = false;
                lstCOMPorts.Enabled = false;
                btnClose.Enabled = true;

                //Clear the textbox and print that we are connected.
                txtDataReceived.Clear();
                txtDataReceived.AppendText("Connected.\r\n");
            }
            catch
            {
                //If there was an exception, then close the handle to 
                //  the device and assume that the device was removed
                btnClose_Click(this, null);
            }
        }

        //Close{^Ǝs܂B
        private void btnClose_Click(object sender, System.EventArgs e)
        {
            //Reset the state of the application objects
            btnClose.Enabled = false;
            btnConnect.Enabled = true;
            lstCOMPorts.Enabled = true;

            try
            {
                //Dispose the In and Out buffers;
                serialPort1.DiscardInBuffer();
                serialPort1.DiscardOutBuffer();

                //Close the COM port
                serialPort1.Close();
            }
            //If there was an exeception then there isn't much we can do.  The port is no longer available.
            catch { }
        }

        //f[^COM|[gŎMƁÅ֐ĂяotxtDataReceivedeLXg{bNXɂ̃f[^݂܂
        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {
            try
            {
                // ReadExistingij֐́ACOM|[g̃obt@Ɍݗp\ȂׂẴf[^ǂݍ݂܂B
                //̗ł́AsetTextij֐Ɏgp\COM|[ĝׂẴf[^𑗐MĂ܂B
                //F<SerialPort>_DataReceivedij֐́AAvP[V̑̕ƗXbhŋN܂B
                //fQ[g@\,ÃXbh̓̊ǗΏۃIuWFNgɃANZX邽߂ɕKvłB
                //ǗΏۃIuWFNgtextBoxɏƂɂȂ܂̂ŁAfQ[g@\v܂B
                //fQ[g̋@\Ƃ̎gp@̏ڍׂɂẮAsetTextij֐QƂĂB
                SetText(serialPort1.ReadExisting());
            }
            catch
            {
                //If there was an exception, then close the handle to the device and assume that the device was removed
                btnClose_Click(this, null);
            }
        }

        //̊֐́AtxtDataReceivedeLXg{bNXɓ͂ꂽeLXgo͂܂B
        //ĂяõXbheLXg{bNXLXbhƓłꍇAappendTextij\bh𒼐ڌĂяo܂B
        //CXbhȊO̊֐Ăяoꍇ́ACXbhōĂюs悤ɁAfQ[g֐̃CX^X쐬܂B
        private void SetText(string text)
        {
            //InvokeRequired͌ĂяõXbhIDƍ쐬XbhID̔r̂ߕKvłB
            //̃XbhقȂĂꍇ́AtrueԂ܂B
            //eLXg{bNXɃeLXg𒼐ڒǉł邩AfQ[g֐̃CX^XNKv邩̑𗘗p܂B
            if (txtDataReceived.InvokeRequired)
            {
                //deleage@\NKv܂B
                //SetTextCallbackfQ[g̃CX^X쐬AfQ[g̋@\蓖Ă܂B
                //͎ÃXbh̑ɁAsetTextij֐ACXbhŌĂяo܂B
                SetTextCallback d = new SetTextCallback(SetText);

                //̃Xbh炱̊֐ɓnꂽeLXg𑗐MVfQ[gĂяo܂
                Invoke(d, new object[] { text });
            }
            else
            {
                //If this function was called from the same thread that 
                //  holds the required objects then just add the text.
                txtDataReceived.AppendText(text);
            }
        }

        //SendData{^ꂽƂɎs܂B
        private void btnSendData_Click(object sender, System.EventArgs e)
        {
            try
            {
                //Write the data in the text box to the open serial port
                serialPort1.Write(txtData.Text);
            }
            catch
            {
                //If there was an exception, then close the handle to 
                //  the device and assume that the device was removed
                btnClose_Click(this, null);
            }
        }

        private void button1_Click(object sender, System.EventArgs e)
        {
            try
            {
                serialPort1.Write(txtData.Text+"\r\n");
            }
            catch
            {
                btnClose_Click(this, null);
            }
        }

        private  void button2_Click(object sender, System.EventArgs e)
        {
            try
            {
                serialPort1.Write("AT+CWMODE=1\r\n");
                MyWait(10);
                serialPort1.Write("AT+CWJAP=\"SSID\",\"password\"\r\n");
                MyWait(600);
                serialPort1.Write("AT+CIFSR\r\n");
                MyWait(60);
                serialPort1.Write("AT+CIPSTART=\"TCP\",\"p\RIPAhX\",|[g\r\n");
                MyWait(200);
                serialPort1.Write("AT+CIPMODE=1\r\n");
                MyWait(100);
                serialPort1.Write("AT+CIPSEND\r\n");
            }
            catch
            {
                btnClose_Click(this, null);
            }
        }

        void MyWait(long Time)
        {
            gTime = 0;
            while (gTime < Time)
            {
                Application.DoEvents();
            }
        }


    }


}

